-- Author      : Skylar State

local SkyUI = SkyUI
local SkyBaseClass = SkyBaseClass
local SkyPartyFrame = SkyUI_CreateClass(SkyBaseClass)
local cfg = SkyUI.Config.PartyFrames
local clr = SkyUI.Config.UnitFrames.Clr
local UpdateInterval = 0.033
local TimeSinceLastUpdate = 0
local evt
local GroupMembers = 1

local Util = {}

local Timer = {}
Timer.__index = Timer;

CreateFrame("Frame", "SkyUIPartyHeader", UIParent, "SecureHandlerStateTemplate")
RegisterStateDriver(SkyUIPartyHeader, "page", "[mod:alt]2;1")
SkyUIPartyHeader:SetAttribute("_onstate-page", [[
    self:SetAttribute("state", newstate)
    control:ChildUpdate("state", newstate)
]])
--local ab = LibStub("LibActionButton")


local function updateTooltip(self)
 if( GameTooltip:IsOwned(self) ) then
  if self.TT.Index == nil then GameTooltip:SetUnit(self.TT.Unit)
  else GameTooltip:SetUnitAura(self.TT.Unit, self.TT.Index, self.TT.Filter) end
 end
end
local function showTooltip(self)
 GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT")
 if self.TT.Index == nil then GameTooltip:SetUnit(self.TT.Unit)
 else GameTooltip:SetUnitAura(self.TT.Unit, self.TT.Index, self.TT.Filter) end

 self:SetScript("OnUpdate", updateTooltip)
end
local function hideTooltip(self) self:SetScript("OnUpdate", nil) GameTooltip:Hide() end



function SkyPartyFrame.prototype:CreateUnitFrame()
 self.F = CreateFrame("Button", SkyUI.BaseName .. self.Name, UIParent, "SecureUnitButtonTemplate")
 self.F:SetPoint(self.RT, self.X, self.Y)
 self.F:SetSize(self.W, self.H)
 self.F:Show()
 self.F.sui = self
end

local function CreateClassIcon(f, size, x, y)
 local t = f:CreateTexture(nil, "OVERLAY")
	t:SetSize(size, size)
	t:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
	t:SetPoint("TOPLEFT", f, x, -y)
 t:SetTexCoord(0,0,0,0)
 return t
end

local function CreatePortrait(f, size, x, y, u)
 local t = f:CreateTexture(nil, "ARTWORK")
 t:SetSize(size, size)
 t:SetPoint("TOPLEFT", f, x, y)
 return t
end

local function CreateRaidIcon(f, size, x, y, u)
 local t = f:CreateTexture(nil, "OVERLAY")
 t:SetSize(size, size)
 t:SetPoint("TOPLEFT", f, x, y)
 t:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
 return t
end

local function CreateRoleIcon(f)
 local t = f:CreateTexture(nil, "OVERLAY")
 t:SetSize(18, 18)
 t:SetPoint("TOPLEFT", f, -11, -17.5)
 t:SetTexture(SkyUI.Specs.PartyFrames.TextureSheet.Path)
 t:SetTexCoord(0, 0, 0, 0)
 return t
end



-- NormalTexture, HotKey, action, NewActionTexture, Border, Flash, Cd, _state_action, icon, flashing, Count,
-- rangeTimer, draenorZoneDisabled, header, id, FlyoutBorderShadow, state_actions, __LAB_Version, 0, config,
-- FlyoutBorder, _state_type, state_types, FlyoutArrow, cooldown, Name, 

local function UpdateTimer(timer, n)
 self = timer.btn.Cd
 local x, y, x1, x2, y1, y2 = 0, 0, 0, 0, 0, 0
 x, y = n % 10, math.floor(n / 10)
 x1,y1 = x*25, y*25
 x2,y2 = x1 + 25, y1 + 25
 self:SetTexCoord(x1/256, x2/256, y1/256, y2/256)
end

local function CreateTimer(party, num, parent, x, y)
-- local timer = {};
-- setmetatable(timer, Timer);
 
-- local btn = ab:CreateButton(69+num, "p" .. party .. "n" .. num, SkyUIPartyHeader)
-- btn:SetState(0, "action", 69+num)
-- btn:SetState(1, "action", 69+num)
-- btn:SetState(2, "action", 69+num)
-- btn:SetAttribute("unit", parent.Unit)
-- timer.btn = btn
 
-- _G["p" .. party .. "n" .. num .. "Flash"]:SetAlpha(0)
-- btn:SetHighlightTexture(nil)
-- _G["p" .. party .. "n" .. num.."cooldown"]:SetAlpha(0)
 -- print(parent.Unit)
-- print(btn:GetAttribute("unit"))
-- timer.Btn = btn
 
-- timer.GetCursor	= Timer.GetCursor;
  
-- btn.Timer = timer
 
 btn:SetSize(19,19)
 btn:SetPoint("TOPLEFT", parent.F, "TOPLEFT", x, y)
 
 btn.icon:SetTexCoord(0.07,0.93,0.07,0.93)
-- btn.icon:SetSize(19,19)

-- timer.Icon:SetPoint("TOPLEFT", btn, "TOPLEFT", 4, -4)

 btn.Cd = btn:CreateTexture(nil, "OVERLAY", 9)
 btn.Cd:SetTexture(SkyUI.Graphics.Timer.Path)
 btn.Cd:SetSize(27, 27)
 btn.Cd:SetPoint("TOPLEFT", btn, "TOPLEFT", -4, 4)
 btn.Cd:SetTexCoord(0, 24/256, 0, 24/256)

-- btn.NormalTexture:SetTexture(nil)

 local str = ""
 for k,v in pairs(_G["p" .. party .. "n" .. num]) do str = str .. k .. ", " end
-- print(str)
 return timer
end

-- 

local roleTypes = { DAMAGER = 3, HEALER = 2, TANK = 1, LEADER = 0, NONE = nil}
local function SetRoleIcon(t, r)
 local role = roleTypes[r]
 
 if role == nil then t:SetTexCoord(0, 0, 0, 0)
 else t:SetTexCoord(1/512,19/512,(269+18*role)/512,(287+18*role)/512) end
end

--local function SetRoleIcon(t, num) t:SetTexCoord(0.001953125,0.037109375,0.525390625,(287+18*num)/512) end
--local function SetRoleIcon(t, num) t:SetTexCoord(1,19,269,287+18*num) end

SkyPartyFrame.prototype.F = nil -- Frame

SkyPartyFrame.prototype.RT = 0 -- RelativeTo Position
SkyPartyFrame.prototype.X = 0
SkyPartyFrame.prototype.Y = 0
SkyPartyFrame.prototype.W = 0
SkyPartyFrame.prototype.H = 0

SkyPartyFrame.prototype.Unit = nil
SkyPartyFrame.prototype.GUID = nil
SkyPartyFrame.prototype.Health = 0
SkyPartyFrame.prototype.Power = 0
SkyPartyFrame.prototype.PowerType = 0

SkyPartyFrame.prototype.TS = nil
SkyPartyFrame.prototype.tO = {X = 0, Y = 0}
SkyPartyFrame.prototype.Txt = nil

SkyPartyFrame.prototype.IsCasting = false --!!
SkyPartyFrame.prototype.CastIsChanneled = false --!!
SkyPartyFrame.prototype.CastEnd = nil --!!
SkyPartyFrame.prototype.CastDuration = nil --!!
SkyPartyFrame.prototype.Spell = nil --!!

SkyPartyFrame.prototype.IncomingHeals = 0 --!!

SkyPartyFrame.prototype.AuraBars = nil --!!
SkyPartyFrame.prototype.AuraBarCount = 0 --!!



function SkyPartyFrame.prototype:init(partyNumber)
 SkyUI["party" .. partyNumber] = self;

 local frameSpec = SkyUI.Specs.PartyFrames.Frames["Party" .. partyNumber]

 self.Name = "party" .. partyNumber
 
 if partyNumber == 0 then self.Unit = "player" else self.Unit = self.Name end
-- self.Unit = "player"
 
-- self.Unit = "player"
 self.RT = frameSpec.RT
 self.X = frameSpec.X + 15
 self.Y = frameSpec.Y + 140
 self.W = frameSpec.W
 self.H = frameSpec.H
 self.T = SkyUI.Specs.PartyFrames.Textures
 self.Txt = SkyUI.Specs.PartyFrames.Text

 self.TS = SkyUI.Specs.PartyFrames.TextureSheet
 self.tO = SkyUI.Specs.PartyFrames.TextureOffset
  
 self:CreateUnitFrame()
 
 self:AddTextures()
 self:AddText()
 
 self.F:EnableMouse(true)
 self.F:SetAttribute("unit", self.Unit)
 self.F:RegisterForClicks("AnyDown")
 self.F:SetAttribute("type1", "target")
 self.F:SetAttribute("type2", "menu")
-- self.F.menu = function(self) ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..partyNumber.."DropDown"], "cursor") end
-- self.F.menu = function(self) ToggleDropDownMenu(1, nil, _G["Party1DropDown"], "cursor") end

 self.F.Portrait = CreatePortrait(self.F, 29, 3, -3, self.Unit)
 self.F.ClassIcon = CreateClassIcon(self.F, 16, 30, 2)
 self.F.Role = CreateRoleIcon(self.F)
 
 self.F.TT = { Unit = self.Unit }

 self:OnConfigUpdated()
 self:Enable()
  
 self.F:Hide()
 
-- self.Timer1 = CreateTimer(partyNumber, 1, self, 140, -7)
-- self.Timer2 = CreateTimer(partyNumber, 2, self, 140+24+10, -7)
-- self.Timer3 = CreateTimer(partyNumber, 3, self, 140+48+20, -7)
 
end


-- self:UpdateUnitName()
-- self:UpdateClassColor()
-- self:UpdateDisplayPower()
-- self:UpdateUnitFrames()
-- self:UpdateUnitReaction()
-- self:AuraUpdates()
--  if sui.ExtraUnits.Pet.Health ~= extraUnits.Pet.Health then sui:UpdateHorzBar(self.PetHealth, extraUnits.Pet.Health, UnitHealthMax(sui.Unit .. "pet"), sui.T.PetHealth) end
--  if sui.ExtraUnits.Pet.Power ~= extraUnits.Pet.Power then sui:UpdateHorzBar(self.PetPower, extraUnits.Pet.Power, UnitPowerMax(sui.Unit .. "pet"), sui.T.PetPower) end

function SkyPartyFrame.prototype:UpdateStats()


end

function SkyPartyFrame.prototype:UpdatePower()
 local powerType = select(1, UnitPowerType(self.Unit))
 if not powerType or UnitPowerMax(self.Unit) == 0 then self.F.Power:SetAlpha(0)
 else
  local powerType = select(1, UnitPowerType(self.Unit))
  self.F.Power:SetVertexColor(clr.PBC[powerType].r, clr.PBC[powerType].g, clr.PBC[powerType].b)
  self.F.Power:SetAlpha(1)
 end
end

function SkyPartyFrame.prototype:UpdateIncomingHeals()
	local incomingHeals = UnitGetIncomingHeals(self.Unit) or 0
 incomingHeals = incomingHeals * 1.06
 if incomingHeals ~= 0 then incomingHeals = incomingHeals + UnitHealth(self.Unit) end
	if incomingHeals >= UnitHealthMax(self.Unit) then incomingHeals = UnitHealthMax(self.Unit) end
 self:UpdateHorzBar("IncomingHealth", incomingHeals, UnitHealthMax(self.Unit))
end


function SkyPartyFrame.prototype:Initialize()
 
 self:SetText_Justified("UnitName", UnitName(self.Unit), nil, "RIGHT", 82)
 self:SetText_Justified("UnitLevel", UnitLevel(self.Unit), nil, "CENTER")

 SetPortraitTexture(self.F.Portrait, self.Unit)
 
 self:UpdatePower()
 
 local t = CLASS_ICON_TCOORDS[select(2,UnitClassBase(self.Unit))]
 if t then self.F.ClassIcon:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles") self.F.ClassIcon:SetTexCoord(unpack(t)) end

 if UnitIsGroupLeader(self.Unit) then SetRoleIcon(self.F.Role, "LEADER") else SetRoleIcon(self.F.Role, UnitGroupRolesAssigned(self.Unit)) end

 self:UpdateStats()
 
 self:UpdateHorzBar("Health", UnitHealth(self.Unit), UnitHealthMax(self.Unit))
 self:UpdateHorzBar("Power", UnitPower(self.Unit), UnitPowerMax(self.Unit))
 self:UpdateIncomingHeals()
 

end


function SkyPartyFrame.prototype:OnConfigUpdated()
-- self.F:SetScale(cfg.UI.Scale)

 self:Initialize()
end





SkyUI.Modules.PartyFrames.OnConfigUpdated = function()
-- print("Party frames")
 if SkyUI.Modules.PartyFrames.Enabled == false then return true end
 for i=0,4 do SkyUI["party" .. i]:OnConfigUpdated() end

-- local frameSpec = SkyUI.Specs.ComboPoints.Frames.Combo
-- local newX, newY = cfg.UI.OffsetX, cfg.UI.OffsetY
end



local counter = 0

local function UpdateParty(self, elapsed)

 if TimeSinceLastUpdate < UpdateInterval then
  TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
		return
	end
 TimeSinceLastUpdate = 0

 local guid, _groupMembers = nil, GetNumSubgroupMembers()
 _groupMembers = _groupMembers + 1

 if _groupMembers > 1 or GroupMembers ~= _groupMembers then
  local unit
  for i=0,4 do
   unit = "party"..i
   guid = UnitGUID(unit)
   if guid == nil then SkyUI[unit].F:Hide()
   elseif self.GUID ~= guid then
    self.GUID = guid
    SkyUI[unit]:Initialize()
    SkyUI[unit].F:Show()
   end
  end
  GroupMembers = _groupMembers
 end

 -- counter = (counter + 3) % 100
 -- UpdateTimer(SkyUI.party1.Timer1, counter)
 -- UpdateTimer(SkyUI.party1.Timer2, 99)
 -- UpdateTimer(SkyUI.party1.Timer3, 99)
 
 -- UpdateTimer(SkyUI.party2.Timer1, 99)
 -- UpdateTimer(SkyUI.party2.Timer2, 99)
 -- UpdateTimer(SkyUI.party2.Timer3, 99)
 -- UpdateTimer(SkyUI.party3.Timer1, 99)
 -- UpdateTimer(SkyUI.party3.Timer2, 99)
 -- UpdateTimer(SkyUI.party3.Timer3, 99)
 -- UpdateTimer(SkyUI.party4.Timer1, 99)
 -- UpdateTimer(SkyUI.party4.Timer2, 99)
 -- UpdateTimer(SkyUI.party4.Timer3, 99)

end


function SkyPartyFrame.prototype:UpdateHorzBar(name, curVal, maxVal) -- , textureOffset, reversedTexture
 if not curVal or maxVal == 0 then return end
 if curVal == 0 then curVal = 0.01 end
 if curVal > maxVal then curVal = maxVal end
 local g, v, t = self.TS, self.T[name], self.F[name]
 
 local p = curVal / maxVal;
  
 local newWidth = v.W * p
 local dif = v.W - newWidth

 local x1, x2, y1, y2 = v.tX / g.W, (v.tX + v.W -dif) / g.W, v.tY / g.H, (v.tY + v.H) / g.H
 
 point, relativeTo, relativePoint, xOfs, yOfs = t:GetPoint()

 t:SetTexCoord(x1, x2, y1, y2)
 t:SetSize(newWidth, v.H)
end



function SkyPartyFrame.prototype:EventManager(evt, unit, arg1, arg2, arg3)
 local sui = self.sui
-- if unit and unit:sub(1,5) ~= "party" then return end
-- if unit and unit:sub(1,5) ~= "playe" then return end
 if unit ~= select(1, UnitName(sui.Unit)) then return end
-- print(evt .. " " .. unit .. " " .. select(1, UnitName(sui.Unit)))

 if evt == "UNIT_DISPLAYPOWER" then
 elseif evt == "UNIT_HEALTH" or evt == "UNIT_MAXHEALTH" then sui:UpdateHorzBar("Health", UnitHealth(sui.Unit), UnitHealthMax(sui.Unit)) sui:UpdateIncomingHeals()
 elseif evt == "UNIT_POWER" or evt == "UNIT_MAXPOWER" then sui:UpdateHorzBar("Power", UnitPower(sui.Unit), UnitPowerMax(sui.Unit))
 elseif evt == "UNIT_HEAL_PREDICTION" then sui:UpdateIncomingHeals()

 elseif evt == "UNIT_DISPLAYPOWER" then
 elseif evt == "ROLE_CHANGED_INFORM" then
  if UnitIsGroupLeader(sui.Unit) then SetRoleIcon(sui.F.Role, "LEADER") else SetRoleIcon(sui.F.Role, arg3) end
 end
  
end

function SkyPartyFrame.prototype:Enable()
-- self.F:SetScript("OnEnter", showTooltip)
-- self.F:SetScript("OnLeave", hideTooltip)
 self.F:SetScript("OnEvent", self.EventManager)
 self.F:RegisterEvent("UNIT_DISPLAYPOWER")
 self.F:RegisterEvent("UNIT_HEALTH")
 self.F:RegisterEvent("UNIT_POWER")
 self.F:RegisterEvent("UNIT_MAXHEALTH")
 self.F:RegisterEvent("UNIT_MAXPOWER")
 self.F:RegisterEvent("UNIT_HEAL_PREDICTION")
 self.F:RegisterEvent("ROLE_CHANGED_INFORM")
end

function SkyPartyFrame.prototype:Disable()
-- self.F:SetScript("OnEnter", nil)
-- self.F:SetScript("OnLeave", nil)
 self:Hide() self.F:Hide()
 self.F:SetScript("OnEvent", nil)
 self.F:UnregisterEvent("UNIT_DISPLAYPOWER")
 self.F:UnregisterEvent("UNIT_HEALTH")
 self.F:UnregisterEvent("UNIT_POWER")
 self.F:UnregisterEvent("UNIT_MAXHEALTH")
 self.F:UnregisterEvent("UNIT_MAXPOWER")
-- self.F:UnregisterEvent("UNIT_PORTRAIT_UPDATE")
 self.F:UnregisterEvent("UNIT_HEAL_PREDICTION")
 self.F:UnregisterEvent("ROLE_CHANGED_INFORM")
end


local function Kill(object) -- courtesy of ElvUI
	if object.UnregisterAllEvents then
		object:UnregisterAllEvents()
--		object:SetParent(E.HiddenFrame)
	else	object.Show = object.Hide	end
	object:Hide()
end

local function HideRaid() -- courtesy of ElvUI
	if InCombatLockdown() then return end
	Kill(CompactRaidFrameManager)
	local compact_raid = CompactRaidFrameManager_GetSetting("IsShown")
	if compact_raid and compact_raid ~= "0" then
		CompactRaidFrameManager_SetSetting("IsShown", "0")
	end
end

local function DisableBlizzard()
	if CompactRaidFrameManager_UpdateShown then
		hooksecurefunc("CompactRaidFrameManager_UpdateShown", HideRaid)
		CompactRaidFrameManager:HookScript('OnShow', HideRaid)
		CompactRaidFrameContainer:UnregisterAllEvents()
		HideRaid()
 end
		--hooksecurefunc("CompactUnitFrame_RegisterEvents", CompactUnitFrame_UnregisterEvents) -- breaks nameplates names
end



SkyUI.Modules.PartyFrames.Enable = function()
-- print(SkyUI.Modules.PartyFrames.Enabled, SkyUI.Specs.PartyFrames.Enabled)
 if SkyUI.Modules.PartyFrames.Enabled or SkyUI.Specs.PartyFrames.Enabled == false then return true end
 cfg.UI.Enabled = true
 SkyUI.Modules.PartyFrames.Enabled = true

 if not evt then evt = CreateFrame("Frame") end
 
 for i=0,4 do
  if SkyUI["party" .. i] then SkyUI["party" .. i]:Enable() else SkyPartyFrame:new(i) end
  local frame = _G["PartyMemberFrame"..i]
  if frame then frame:UnregisterAllEvents() frame:Hide() frame.Show = function() end end
 end
 
 
 evt:SetScript("OnUpdate", UpdateParty)

 
-- RegisterStateDriver(ComboFrame, "visibility", "hide")
 
-- SkyUI.player:AuraUpdates()

-- DisableBlizzard()

end

SkyUI.Modules.PartyFrames.Disable = function()
 if not SkyUI.Modules.PartyFrames.Enabled then return true end
 cfg.UI.Enabled = false
 SkyUI.Modules.PartyFrames.Enabled = false
 
 for i=0,4 do
  if SkyUI["party" .. i] then SkyUI["party" .. i]:Disable() end
 	local frame = _G["PartyMemberFrame"..i]
  if frame then	frame.Show = nil frame:GetScript("OnLoad")(frame) PartyMemberFrame_UpdateMember(frame) end
 end
 
 evt:SetScript("OnEvent", nil)
 evt:SetScript("OnUpdate", nil)

-- UnregisterStateDriver(ComboFrame, "visibility")
end




--ComboFrame:Hide()
--ComboFrame:UnregisterAllEvents()






