
local sui, cfg, suf, smu, cpf, pfc = SkyUI, SkyUI.Config, SkyUI.Config.UnitFrames, SkyUI.Modules.UnitFrames, ColorPickerFrame, SkyUI.Config.PartyFrames
local _SavePending, _Save, evt = false, {}, nil

local clrs = {
  HUNTER = "cCCHunter", WARRIOR = "cCCWarrior", PALADIN = "cCCPaladin", MAGE = "cCCMage", PRIEST = "cCCPriest", SHAMAN = "cCCShaman", WARLOCK = "cCCWarlock",
  DEMONHUNTER = "cCCDemonHunter", DEATHKNIGHT = "cCCDeathKnight", DRUID = "cCCDruid", MONK = "cCCMonk", ROGUE = "cCCRogue",
  
  MANA = "cCCMana", RAGE = "cCCRage", FOCUS = "cCCFocus", ENERGY = "cCCEnergy", COMBO_POINTS = "cCCComboPoints", CHI = "cCCChi", RUNES = "cCCRunes", RUNIC_POWER = "cCCRunicPower", 
  SOUL_SHARDS = "cCCSoulShards", LUNAR_POWER = "cCCLunarPower", HOLY_POWER = "cCCHolyPower", MAELSTROM = "cCCMaelstrom", INSANITY = "cCCInsanity", FURY = "cCCFury", PAIN = "cCCPain",
 }

local function round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end

local mnuitems = {}

local function SaveValues(c)
 if c then _Save[c.name] = true end
 if InCombatLockdown() then _SavePending = true return true end

 if _Save["cHud"] then if mnuitems.cHud:GetChecked() then smu.Disable() else smu.Enable() end end
-- if _Save["cActionBars"] then if mnuitems.cActionBars:GetChecked() then SkyUI.Modules.ActionBars.Disable() else SkyUI.Modules.ActionBars.Enable() end end
 
 if _Save["cFocus"] then suf.focus.Enabled = mnuitems.cFocus:GetChecked() end
 if _Save["cPet"] then suf.playerpet.Enabled = mnuitems.cPet:GetChecked() end
 if _Save["cPetTarget"] then suf.playerpettarget.Enabled = mnuitems.cPetTarget:GetChecked() end
 if _Save["cTargetTarget"] then suf.targettarget.Enabled = mnuitems.cTargetTarget:GetChecked() end
 if _Save["cTargetPet"] then suf.targetpet.Enabled = mnuitems.cTargetPet:GetChecked() end
 if _Save["cTargetPetTarget"] then suf.targetpettarget.Enabled = mnuitems.cTargetPetTarget:GetChecked() end
 if _Save["cStatK"] then if mnuitems.cStatK:GetChecked() then suf.UI.K = "K" else suf.UI.K = "" end end
 
 if _Save["HudScale"] then suf.UI.Scale = round(mnuitems.HudScale:GetValue()) / 100 end

 if _Save["HorzOffset"] then suf.UI.OffsetX = round(mnuitems.HorzOffset:GetValue()) end
 if _Save["VertOffset"] then suf.UI.OffsetY = round(mnuitems.VertOffset:GetValue()) end

 if _Save["cParty"] then if mnuitems.cParty:GetChecked() then SkyUI.Modules.PartyFrames.Disable() else SkyUI.Modules.PartyFrames.Enable() end end

 if _Save["cAuras"] then if mnuitems.cAuras:GetChecked() then smu.Auras.Disable() else smu.Auras.Enable() end end
 if _Save["cShowAll"] then smu.Auras.ShowAll = mnuitems.cShowAll:GetChecked() end

  if _Save["cSwap"] then suf.Auras.Swap = mnuitems.cSwap:GetChecked() end
 if _Save["cCDBD"] then suf.Auras.CooldownBackdrop = not mnuitems.cCDBD:GetChecked() end

 if _Save["cBuffs"] then suf.Auras.Buffs.Enabled = not mnuitems.cBuffs:GetChecked() end
 if _Save["cBuffBar"] then suf.Auras.Buffs.Bars = mnuitems.cBuffBar:GetChecked() end
 if _Save["cBuffName"] then suf.Auras.Buffs.Names = mnuitems.cBuffName:GetChecked() end
 if _Save["cBuffCD"] then suf.Auras.Buffs.CD = mnuitems.cBuffCD:GetChecked() end
 if _Save["cPlayerBuffs"] then suf.Auras.Buffs.PlayerOnly = mnuitems.cPlayerBuffs:GetChecked() end

 if _Save["cDebuffs"] then suf.Auras.Debuffs.Enabled = not mnuitems.cDebuffs:GetChecked() end
 if _Save["cDebuffBar"] then suf.Auras.Debuffs.Bars = mnuitems.cDebuffBar:GetChecked() end
 if _Save["cDebuffName"] then suf.Auras.Debuffs.Names = mnuitems.cDebuffName:GetChecked() end
 if _Save["cDebuffCD"] then suf.Auras.Debuffs.CD = mnuitems.cDebuffCD:GetChecked() end
 if _Save["cPlayerDebuffs"] then suf.Auras.Debuffs.PlayerOnly = mnuitems.cPlayerDebuffs:GetChecked() end

 if _Save["MaxBuffBars"] then suf.Auras.Buffs.Max = round(mnuitems.MaxBuffBars:GetValue()) end
 if _Save["MaxDebuffBars"] then suf.Auras.Debuffs.Max = round(mnuitems.MaxDebuffBars:GetValue()) end

 if _Save["cRange"] then suf.RangeTransparency = mnuitems.cRange:GetChecked() end

 if _Save["cOOCAlpha"] then suf.UI.player.OOCAlpha = round(mnuitems.cOOCAlpha:GetValue()) / 100 end
 if _Save["cCombatAlpha"] then suf.UI.player.CombatAlpha = round(mnuitems.cCombatAlpha:GetValue()) / 100 end

 if _Save["cInsideAlpha"] then suf.UI.target.InsideAlpha = round(mnuitems.cInsideAlpha:GetValue()) / 100 end
 if _Save["cOutsideAlpha"] then suf.UI.target.OutsideAlpha = round(mnuitems.cOutsideAlpha:GetValue()) / 100 end
 
 if _Save["cComboPoints"] then if mnuitems.cComboPoints:GetChecked() then sui.Modules.ComboPoints.Enable() else sui.Modules.ComboPoints.Disable() end end

 if _Save["comboHorzOffset"] then cfg.ComboPoints.UI.OffsetX = round(mnuitems.comboHorzOffset:GetValue()) end
 if _Save["comboVertOffset"] then cfg.ComboPoints.UI.OffsetY = round(mnuitems.comboVertOffset:GetValue()) end

 
 if _Save["cFrameColor"] then suf.Clr[mnuitems.cFrameColor.cfgVal] = mnuitems.cFrameColor.clr end
 if _Save["cFrameFlair"] then suf.Clr[mnuitems.cFrameFlair.cfgVal] = mnuitems.cFrameFlair.clr end
 if _Save["cFriendlyHealthColor"] then suf.Clr[mnuitems.cFriendlyHealthColor.cfgVal] = mnuitems.cFriendlyHealthColor.clr end
 if _Save["cTrivial"] then suf.Clr[mnuitems.cTrivial.cfgVal] = mnuitems.cTrivial.clr end

 if _Save["cNonInterruptibleSpell"] then suf.Clr[mnuitems.cNonInterruptibleSpell.cfgVal] = mnuitems.cNonInterruptibleSpell.clr end
 if _Save["cFriendlySpell"] then suf.Clr[mnuitems.cFriendlySpell.cfgVal] = mnuitems.cFriendlySpell.clr end
 if _Save["cHostileSpell"] then suf.Clr[mnuitems.cHostileSpell.cfgVal] = mnuitems.cHostileSpell.clr end

 
 for k, v in pairs(clrs) do if _Save[v] then suf.Clr[k] = mnuitems[v].clr end end
 suf.Clr.PBC = {[0]=suf.Clr.MANA, [1]=suf.Clr.RAGE, [2]=suf.Clr.FOCUS, [3]=suf.Clr.ENERGY, [4]=suf.Clr.CHI, [5]=suf.Clr.RUNES, [6]=suf.Clr.RUNIC_POWER, [7]=suf.Clr.SOUL_SHARDS, [8]=suf.Clr.LUNAR_POWER, [9]=suf.Clr.HOLY_POWER, [11]=suf.Clr.MAELSTROM, [13]=suf.Clr.INSANITY, [17]=suf.Clr.FURY, [18]=suf.Clr.PAIN};

 if _Save["cBuffColor"] then suf.Clr[mnuitems.cBuffColor.cfgVal] = mnuitems.cBuffColor.clr end
 if _Save["cDebuffColor"] then suf.Clr[mnuitems.cDebuffColor.cfgVal] = mnuitems.cDebuffColor.clr end
 
 
 if _Save["cHealthByClass"] then
  if mnuitems.cHealthByClass:GetChecked() then suf.ColorOptions.Health = sui.Structs.By.Class
  else suf.ColorOptions.Health = sui.Structs.By.Default end
 end
 
 if _Save["cUnitBorderByClass"] then
  if mnuitems.cUnitBorderByClass:GetChecked() then suf.ColorOptions.UnitBorder = sui.Structs.By.Class
  else suf.ColorOptions.UnitBorder = sui.Structs.By.Default end
 end
  
 if _Save["cUnitFlairByClass"] then
  if mnuitems.cUnitFlairByClass:GetChecked() then suf.ColorOptions.UnitFlair = sui.Structs.By.Class
  else suf.ColorOptions.UnitFlair = sui.Structs.By.Default end
 end
 
 
 sui.Modules.Main:OnConfigUpdated()
 _SavePending = false
 _Save = {}
end


local function PlaceBG(mnu, rf, w, h, name, clr, pad)

 local bg = mnu:CreateTexture("cfg" .. name .. "bg", "BACKGROUND")
 bg:ClearAllPoints()
 bg:SetSize(w, h)
 bg:SetPoint("TOPLEFT", rf, "TOPLEFT", 1 + pad.x, -3 + pad.y)
 bg:SetColorTexture(clr.r, clr.g, clr.b, clr.a)

end

local function PlaceCheckBox(mnu, x, y, rt, name, txt)
 local f = CreateFrame("CheckButton", "cfg" .. name, mnu, "UICheckButtonTemplate")
 mnuitems[name] = f
 f.name = name
 f:ClearAllPoints()

--*TOPLEFT  *TOP  *TOPRIGHT
--LEFT    CENTER   RIGHT
--*BTMLEFT  *BTM  *BTMRIGHT

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 55 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 25 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 25 end
 f:SetPoint(rt, x, y)
 
 f:SetSize(25, 25)
 _G["cfg" .. name .. "Text"]:SetText(" " .. txt)

 local fnt = SkyUI.Strings.Header
 _G["cfg" .. name .. "Text"]:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 _G["cfg" .. name .. "Text"]:SetTextColor(1, 1, 1, 1)
-- _G["cfg" .. name .. "Text"]:SetFontObject(GameFontNormal)
 _G["cfg" .. name .. "Text"]:SetPoint("LEFT", 23, 1)
-- MakeMovable(frame)
 f:SetScript("OnClick", SaveValues)
 
 
-- (point, relativeFrame, relativePoint, ofsx, ofsy);
-- PlaceBG(mnu, f, 200, 18, name, {r = 0.1, g = 0.1, b = 0.1, a = 0}, {x = 0, y = 0})
 
end


local function Slider_ValueChanged(this)
 mnuitems[this._EditBox]:SetText(round(this:GetValue()))
 SaveValues(this)
end


local function EditBox_EnterPressed(this)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText())
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
 this:ClearFocus()
end

local function EditBox_MouseWheel(this, delta)
 local s = mnuitems[this._Slider]
 local v = tonumber(this:GetText()) + delta
 if not v then v = 0 end
 local min, max = s:GetMinMaxValues()
 if v < min then v = min elseif v > max then v = max end
 s:SetValue(v)
 this:SetText(v)
end


local function EditBox_FocusLost(this)
 SaveValues(this)
end


local function PlaceText(mnu, x, y, rt, name, txt, slider)
 local f = CreateFrame("EditBox", "cfg" .. name, mnu, "InputBoxTemplate")
 mnuitems[name] = f
 f.name = name

 f:ClearAllPoints()
 
-- if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
-- if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end

 f:SetPoint(rt, x, y)
 f:SetParent(mnu)
 
 f:SetSize(44, 22)
 f:SetTextInsets(0,4,7,5)
 f._Slider = slider
 
 f:SetText(txt)

 f:SetFontObject(GameFontHighlight)
 f:SetJustifyH("CENTER")
 
 f:SetMaxLetters(5)
 
 f:SetAutoFocus(false)
 
 f:SetScript("OnEscapePressed", function(this) this:ClearFocus() end)
 f:SetScript("OnEnterPressed", EditBox_EnterPressed)
 f:SetScript("OnMouseWheel", EditBox_MouseWheel)
 f:SetScript("OnEditFocusLost", EditBox_FocusLost)
end



local function PlaceString(mnu, x, y, rt, name, txt, fnt)
 
 local str = mnu:CreateFontString("cfg" .. name)
 
 mnuitems[name] = str
 str.name = name
 str:ClearAllPoints()

 str:SetFont(fnt.Font, fnt.Size, fnt.Flags)
 str:SetPoint(rt, x, y)
 str:SetJustifyH("LEFT")
 str:SetText(txt)
 str:SetTextColor(1, 1, 1, 1)
 --:SetVertexColor(v.Clr.r, v.Clr.g, v.Clr.b, v.Clr.a)
 return str
end


local function PlaceSlider(mnu, x, y, rt, w, name, txt, minVal, maxVal, val, default)

 local f = CreateFrame("Slider", "cfg" .. name, mnu, "OptionsSliderTemplate")

 mnuitems[name] = f
 f.name = name

 if not val then val = default end

 f:ClearAllPoints()
 
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 f:SetPoint(rt, x, y)

 f:SetSize(w - 60, 15)
 f:SetOrientation("HORIZONTAL")
 
 PlaceText(mnu, x + w - 45, y, rt, name .. "Val", default, name)
 f._EditBox = name .. "Val"
 
 f:SetMinMaxValues(minVal, maxVal);
 f:SetValueStep(1);
 f.DefaultValue = default
 f:SetValue(val)
 f:Show()
 
-- DEFAULT_CHAT_FRAME:AddMessage(["cfg" .. name .. "Low"])
 
 getglobal("cfg" .. name .. "Low"):SetText(minVal)
 getglobal("cfg" .. name .. "High"):SetText(maxVal)
 
 local fnt = SkyUI.Strings.Header
 getglobal("cfg" .. name .. "Text"):SetFont(fnt.Font, fnt.Size, fnt.Flags)
 getglobal("cfg" .. name .. "Text"):SetTextColor(1, 1, 1, 1)
 getglobal("cfg" .. name .. "Text"):SetText(txt)

 
 f:SetScript("OnValueChanged", Slider_ValueChanged)

end

local function PlaceHeader(mnu, x, y, rt, w, name, txt)
 x = x + 8
 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 local str = PlaceString(mnu, x, y, rt, name, txt, SkyUI.Strings.Header)
 
 PlaceBG(mnu, str, w, 20, name, {r = 0.15, g = 0.15, b = .15, a = 1}, {x = -4, y = 7})
end

local function Round(num, idp) return tonumber(string.format("%." .. (idp or 0) .. "f", num)) end

local currentPicker, originalClr = nil, nil
local function changeClr()
 local r, g, b = cpf:GetColorRGB();
 r, g, b = Round(r, 5), Round(g, 5), Round(b, 5)
 currentPicker.clrTexture:SetColorTexture(r, g, b, 1)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = r, g, b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
end

local function opacityClr()
 local r, g, b = cpf:GetColorRGB();
 r, g, b = Round(r, 5), Round(g, 5), Round(b, 5)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = r, g, b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
end

local function cancelClr()
 currentPicker.clrTexture:SetColorTexture(originalClr.r, originalClr.g, originalClr.b, 1)
 currentPicker.clr.r, currentPicker.clr.g, currentPicker.clr.b, currentPicker.clr.a = originalClr.r, originalClr.g, originalClr.b, 1
 SaveValues(currentPicker)
 SkyUI.player:UpdateUnitReaction()
 SkyUI.target:UpdateUnitReaction()
 currentPicker, originalClr = nil, nil
end

local function colorClick(self, bnt)

 cpf.func = changeClr
 cpf.opacityFunc = opacityClr
 cpf.cancelFunc = cancelClr

 currentPicker = self
 originalClr = {r = self.clr.r, g = self.clr.g, b = self.clr.b, a = self.clr.a}
 
 cpf:SetColorRGB(self.clr.r, self.clr.g, self.clr.b);
 cpf:Hide();
 cpf:Show();

end


    
local function PlaceColorPickerBox(mnu, x, y, rt, name, txt, clr, cfgVal)
 x = x + 8

 if rt == "TOPLEFT" or rt == "TOP" or rt == "TOPRIGHT" then y = -y - 30 elseif rt == "BOTTOMLEFT" or rt == "BOTTOM" or rt == "BOTTOMRIGHT" then  y = y + 50 end
 if rt == "TOPLEFT" or rt == "LEFT" or rt == "BOTTOMLEFT" then x = x + 20 elseif rt == "TOPRIGHT" or rt == "RIGHT" or rt == "BOTTOMRIGHT" then x = x - 20 end
 
 local str = PlaceString(mnu, x+20, y-2, "TOPLEFT", "cfg" .. name .. "txt", txt, SkyUI.Strings.Header)

 local f = CreateFrame("Button", "cfg" .. name, mnu)
 f:ClearAllPoints()
 mnuitems[name] = f

 f:RegisterForClicks("AnyUp")
 f:SetScript("OnClick", colorClick)

 f:SetPoint(rt, mnu, "TOPLEFT", x, y)
 f:SetSize(16, 16)

 f.clr = clr
 f.name = name
 f.cfgVal = cfgVal

 local t = f:CreateTexture(nil, "ARTWORK")
 f.clrTexture = t
 
 t:SetAllPoints(f)
 t:SetColorTexture(clr.r, clr.g, clr.b, 1)
 

end


local function OnEventCB(self, evt, ...)
 if evt == "PLAYER_REGEN_ENABLED" then if _SavePending then SaveValues() end
 elseif evt == "PLAYER_REGEN_DISABLED" then SkyUIConfigMenu:Hide() end
end

function ConfigMenu_Loaded()
 SkyUIConfigMenu:SetPoint("TOP", cfg.ConfigMenu.L, cfg.ConfigMenu.T)
 
 if not evt then evt = CreateFrame("Frame")
  SkyUIConfigMenu:HookScript("OnShow",
   function(self)
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    if not InCombatLockdown() and _SavePending then SaveValues() end
   end)
  SkyUIConfigMenu:HookScript("OnHide", function(self) self:UnregisterEvent("PLAYER_REGEN_DISABLED") self:UnregisterEvent("PLAYER_REGEN_ENABLED") end)
  SkyUIConfigMenu:SetScript("OnEvent", OnEventCB)
 end

 local mnu = SkyUIConfigMenu

 -- Tab 1
 PlaceCheckBox(cfgTab1, 0, 10, "TOPLEFT", "cHud", "Disable SkyUI")

 PlaceSlider(cfgTab1, 10, 50, "TOPLEFT", 450, "HudScale", "Hud Scale %", 50, 250, suf.Scale, 100)
 PlaceSlider(cfgTab1, 10, 100, "TOPLEFT", 450, "VertOffset", "Vertical Position", -300, 500, suf.OffsetY, 0)
 PlaceSlider(cfgTab1, 10, 150, "TOPLEFT", 450, "HorzOffset", "Horizontal Position", -400, 50, suf.OffsetX, 0)

-- PlaceText(cfgTab1, 0, 85, "TOP", "HorzOffsetVal", "0", "HorzOffset")
-- PlaceText(cfgTab1, 0, 165, "TOP", "VertOffsetVal", "0", "VertOffset")

 PlaceHeader(cfgTab1, 0, 75, "BOTTOMLEFT", 120, "PlayerFrames", "Player")
 PlaceHeader(cfgTab1, 130, 75, "BOTTOMLEFT", 120, "TargetFrames", "Target")
 PlaceHeader(cfgTab1, 260, 75, "BOTTOMLEFT", 185, "MiscHud", "Misc")

 PlaceCheckBox(cfgTab1, 0, 40, "BOTTOMLEFT", "cFocus", "Focus")
 PlaceCheckBox(cfgTab1, 0, 20, "BOTTOMLEFT", "cPet", "Pet")
 PlaceCheckBox(cfgTab1, 0, 0, "BOTTOMLEFT", "cPetTarget", "Pet's Target")

 PlaceCheckBox(cfgTab1, 130, 40, "BOTTOMLEFT", "cTargetTarget", "Target")
 PlaceCheckBox(cfgTab1, 130, 20, "BOTTOMLEFT", "cTargetPet", "Pet")
 PlaceCheckBox(cfgTab1, 130, 0, "BOTTOMLEFT", "cTargetPetTarget", "Pet's Target") 
 
 PlaceCheckBox(cfgTab1, 260, 40, "BOTTOMLEFT", "cStatK", "Use K for thousands") 
 
 PlaceCheckBox(cfgTab2, 0, 10, "TOPLEFT", "cParty", "Disable Party Frames")
 
 -- Tab 2 (Used to be for actionbars)

 -- Tab 3
 PlaceCheckBox(cfgTab3, 0, 10, "TOPLEFT", "cAuras", "Disable Auras")
 PlaceCheckBox(cfgTab3, 0, 30, "TOPLEFT", "cShowAll", "Testing/Show All")
 PlaceCheckBox(cfgTab3, 235, 10, "TOPLEFT", "cSwap", "Swap Aura Positions")
 PlaceCheckBox(cfgTab3, 235, 30, "TOPLEFT", "cCDBD", "Disable Cooldown Backdrop")

 PlaceHeader(cfgTab3, 0, 82, "TOPLEFT", 210, "Buffs", "Buffs")
 PlaceHeader(cfgTab3, 235, 82, "TOPLEFT", 210, "Debuffs", "Debuffs")

 PlaceCheckBox(cfgTab3, 0, 104, "TOPLEFT", "cBuffs", "Disable")
 PlaceCheckBox(cfgTab3, 0, 130, "TOPLEFT", "cBuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 0, 150, "TOPLEFT", "cBuffName", "Names")
 PlaceCheckBox(cfgTab3, 0, 170, "TOPLEFT", "cBuffCD", "Countdowns")
 PlaceCheckBox(cfgTab3, 0, 200, "TOPLEFT", "cPlayerBuffs", "Player Buffs Only")
 PlaceColorPickerBox(cfgTab3, 0, 230, "TOPLEFT", "cBuffColor", "Buff Bar Color", {r = 0, g = 0.5, b = 0.5 }, "Buff")

 
 PlaceCheckBox(cfgTab3, 235, 104, "TOPLEFT", "cDebuffs", "Disable")
 PlaceCheckBox(cfgTab3, 235, 130, "TOPLEFT", "cDebuffBar", "Bars")
 PlaceCheckBox(cfgTab3, 235, 150, "TOPLEFT", "cDebuffName", "Names")
 PlaceCheckBox(cfgTab3, 235, 170, "TOPLEFT", "cDebuffCD", "Countdowns")
 PlaceCheckBox(cfgTab3, 235, 200, "TOPLEFT", "cPlayerDebuffs", "Player Debuffs Only")
 PlaceColorPickerBox(cfgTab3, 235, 230, "TOPLEFT", "cDebuffColor", "Debuff Bar Color", {r = 0.5, g = 0, b = 1 }, "Debuff")

 
 PlaceSlider(cfgTab3, 10, 300, "TOPLEFT", 200, "MaxBuffBars", "Max Buff Bars", 0, 12, suf.Auras.Buffs.Max, 8)
 PlaceSlider(cfgTab3, 245, 300, "TOPLEFT", 200, "MaxDebuffBars", "Max Debuff Bars", 0, 12, suf.Auras.Debuffs.Max, 8)

-- PlaceText(cfgTab3, 95, 270, "TOPLEFT", "MaxBuffBarsVal", "8", "MaxBuffBars")
-- PlaceText(cfgTab3, 325, 270, "TOPLEFT", "MaxDebuffBarsVal", "8", "MaxDebuffBars")

 -- Tab 4
 PlaceHeader(cfgTab4, 0, 10, "TOPLEFT", 450, "TargetAlphas", "Target Frame Transparency")

 PlaceCheckBox(cfgTab4, 0, 40, "TOPLEFT", "cRange", "Range Transparency")


 PlaceSlider(cfgTab4, 10, 90, "TOPLEFT", 200, "cInsideAlpha", "In Range Alpha %", 0, 100, suf.UI.OOCAlpha, 100)
 PlaceSlider(cfgTab4, 245, 90, "TOPLEFT", 200, "cOutsideAlpha", "Out of Range Alpha %", 0, 100, suf.UI.CombatAlpha, 55)

-- PlaceText(cfgTab4, 95, 110, "TOPLEFT", "cInsideAlphaVal", "100", "cInisideAlpha")
-- PlaceText(cfgTab4, 325, 110, "TOPLEFT", "cOutsideAlphaVal", "100", "cOutsideAlpha")


 PlaceHeader(cfgTab4, 0, 160, "TOPLEFT", 445, "PlayerAlphas", "Player Frame Transparency")

 PlaceSlider(cfgTab4, 10, 210, "TOPLEFT", 200, "cOOCAlpha", "Out of Combat Alpha %", 0, 100, suf.UI.OOCAlpha, 100)
 PlaceSlider(cfgTab4, 245, 210, "TOPLEFT", 200, "cCombatAlpha", "In Combat Alpha %", 0, 100, suf.UI.CombatAlpha, 100)

-- PlaceText(cfgTab4, 95, 230, "TOPLEFT", "cOOCAlphaVal", "100", "cOOCAlpha")
-- PlaceText(cfgTab4, 325, 230, "TOPLEFT", "cCombatAlphaVal", "100", "cCombatAlpha")


 
 PlaceCheckBox(cfgTab5, 0, 10, "TOPLEFT", "cComboPoints", "Enable Combo Points")
 
 PlaceSlider(cfgTab5, 10, 60, "TOPLEFT", 440, "comboHorzOffset", "Horizontal Position", -400, 400, cfg.ComboPoints.UI.OffsetX, 0)
 PlaceSlider(cfgTab5, 10, 140, "TOPLEFT", 440, "comboVertOffset", "Vertical Position", -500, 500, cfg.ComboPoints.UI.OffsetY, 0)

-- PlaceText(cfgTab5, 0, 85, "TOP", "comboHorzOffsetVal", "0", "comboHorzOffset")
-- PlaceText(cfgTab5, 0, 165, "TOP", "comboVertOffsetVal", "0", "comboVertOffset")
  
 
 PlaceColorPickerBox(cfgTab6, 0, 10, "TOPLEFT", "cFrameColor", "Unit Borders", {r = 0.2, g = 0.2, b = 0.2, a = 1}, "Dark")
 PlaceColorPickerBox(cfgTab6, 0, 30, "TOPLEFT", "cFrameFlair", "Border Flair", {r = 1, g = 1, b = 1, a = 0.1}, "Underlay")
 PlaceColorPickerBox(cfgTab6, 0, 50, "TOPLEFT", "cFriendlyHealthColor", "Friendly Healthbars", {r=1, g=0, b=0.5, a=1}, "HealthFriendly")
 PlaceColorPickerBox(cfgTab6, 0, 70, "TOPLEFT", "cTrivial", "Trivial Mob Color", {r=0.4, g=0.4, b=0.4}, "HealthTrivial")

 PlaceColorPickerBox(cfgTab6, 0, 90, "TOPLEFT", "cNonInterruptibleSpell", "Spell Non-Interruptible", { r = 1, g = 1, b = 1 }, "NonInterruptible")
 PlaceColorPickerBox(cfgTab6, 0, 110, "TOPLEFT", "cFriendlySpell", "Spell Friendly", { r = 121/256, g = 219/256, b = 256/256 }, "FriendlySpell")
 PlaceColorPickerBox(cfgTab6, 0, 130, "TOPLEFT", "cHostileSpell", "Spell Hostile", { r = 0.668, g = 0, b = 0 }, "HostileSpell")
 
 PlaceColorPickerBox(cfgTab6, 200, 10, "TOPLEFT", "cCCHunter", "Hunter", {r = 0.67, g = 0.83, b = 0.45, a = 1}, "HUNTER")
 PlaceColorPickerBox(cfgTab6, 200, 30, "TOPLEFT", "cCCWarrior", "Warrior", {r = 0.78, g = 0.61, b = 0.43, a = 1}, "WARRIOR")
 PlaceColorPickerBox(cfgTab6, 200, 50, "TOPLEFT", "cCCPaladin", "Paladin", {r = 0.96, g = 0.55, b = 0.73, a = 1}, "PALADIN")
 PlaceColorPickerBox(cfgTab6, 200, 70, "TOPLEFT", "cCCMage", "Mage", {r = 0.25, g = 0.78, b = 0.92, a = 1}, "MAGE")
 PlaceColorPickerBox(cfgTab6, 200, 90, "TOPLEFT", "cCCPriest", "Priest", {r = 1, g = 1, b = 1, a = 1}, "PRIEST")
 PlaceColorPickerBox(cfgTab6, 200, 110, "TOPLEFT", "cCCShaman", "Shaman", {r = 0, g = 0.44, b = 0.87, a = 1}, "SHAMAN")
 PlaceColorPickerBox(cfgTab6, 200, 130, "TOPLEFT", "cCCWarlock", "Warlock", {r = 0.53, g = 0.53, b = 0.93, a = 1}, "WARLOCK")
 PlaceColorPickerBox(cfgTab6, 200, 150, "TOPLEFT", "cCCDemonHunter", "Demon Hunter", {r = 0.64, g = 0.19, b = 0.79, a = 1}, "DEMONHUNTER")
 PlaceColorPickerBox(cfgTab6, 200, 170, "TOPLEFT", "cCCDeathKnight", "Death Knight", {r = 0.77, g = 0.12, b = 0.23, a = 1}, "DEATHKNIGHT")
 PlaceColorPickerBox(cfgTab6, 200, 190, "TOPLEFT", "cCCDruid", "Druid", {r = 1, g = 0.49, b = 0.04, a = 1}, "DRUID")
 PlaceColorPickerBox(cfgTab6, 200, 210, "TOPLEFT", "cCCMonk", "Monk", {r = 0, g = 1, b = 0.59, a = 1}, "MONK")
 PlaceColorPickerBox(cfgTab6, 200, 230, "TOPLEFT", "cCCRogue", "Rogue", {r = 1, g = 0.96, b = 0.41, a = 1}, "ROGUE")

 PlaceColorPickerBox(cfgTab6, 330, 10, "TOPLEFT", "cCCMana", "Mana", { r = 0, g = 0, b = 1, a = 1 }, "MANA")
 PlaceColorPickerBox(cfgTab6, 330, 30, "TOPLEFT", "cCCRage", "Rage", { r = 1.00, g = 0.00, b = 0.00 }, "RAGE")
 PlaceColorPickerBox(cfgTab6, 330, 50, "TOPLEFT", "cCCFocus", "Focus", { r = 1.00, g = 0.50, b = 0.25 }, "FOCUS")
 PlaceColorPickerBox(cfgTab6, 330, 70, "TOPLEFT", "cCCEnergy", "Energy", { r = 1.00, g = 1.00, b = 0.00 }, "ENERGY")
 PlaceColorPickerBox(cfgTab6, 330, 90, "TOPLEFT", "cCCComboPoints", "Combo Points", { r = 1.00, g = 1.00, b = 0.00 }, "COMBO_POINTS")
 PlaceColorPickerBox(cfgTab6, 330, 110, "TOPLEFT", "cCCChi", "Chi", { r = 0.71, g = 1.0, b = 0.92, rT = 0.71 }, "CHI")
 PlaceColorPickerBox(cfgTab6, 330, 130, "TOPLEFT", "cCCRunes", "Runes", { r = 0.50, g = 0.50, b = 0.50 }, "RUNES")
 PlaceColorPickerBox(cfgTab6, 330, 150, "TOPLEFT", "cCCRunicPower", "Runic Power", { r = 0.00, g = 0.82, b = 1.00 }, "RUNIC_POWER")
 PlaceColorPickerBox(cfgTab6, 330, 170, "TOPLEFT", "cCCSoulShards", "Soul Shards", { r = 0.50, g = 0.32, b = 0.55 }, "SOUL_SHARDS")
 PlaceColorPickerBox(cfgTab6, 330, 190, "TOPLEFT", "cCCLunarPower", "Lunar Power", { r = 0.30, g = 0.52, b = 0.90}, "LUNAR_POWER")
 PlaceColorPickerBox(cfgTab6, 330, 210, "TOPLEFT", "cCCHolyPower", "Holy Power", { r = 0.95, g = 0.90, b = 0.60 }, "HOLY_POWER")
 PlaceColorPickerBox(cfgTab6, 330, 230, "TOPLEFT", "cCCMaelstrom", "Maelstrom", { r = 0.00, g = 0.50, b = 1.00 }, "MAELSTROM")
 PlaceColorPickerBox(cfgTab6, 330, 250, "TOPLEFT", "cCCInsanity", "Insanity", { r = 0.40, g = 0, b = 0.80}, "INSANITY")
 PlaceColorPickerBox(cfgTab6, 330, 270, "TOPLEFT", "cCCFury", "Fury", { r = 0.788, g = 0.259, b = 0.992 }, "FURY")
 PlaceColorPickerBox(cfgTab6, 330, 290, "TOPLEFT", "cCCPain", "Pain", { r = 255/255, g = 156/255, b = 0 }, "PAIN")

 
 PlaceCheckBox(cfgTab6, 0, 0, "BOTTOMLEFT", "cUnitFlairByClass", "Color Unit Flair By Class")
 PlaceCheckBox(cfgTab6, 0, 20, "BOTTOMLEFT", "cUnitBorderByClass", "Color Unit Border By Class")
 PlaceCheckBox(cfgTab6, 0, 40, "BOTTOMLEFT", "cHealthByClass", "Color Unit Health By Class")

end

SkyUI.OnConfigLoaded = function ()
 if InCombatLockdown() then return true end
 
 local cfg = SkyUI.Config
 
 mnuitems.cHud:SetChecked(not suf.UI.Enabled)

 mnuitems.cFocus:SetChecked(suf.focus.Enabled)
 mnuitems.cPet:SetChecked(suf.playerpet.Enabled)
 mnuitems.cPetTarget:SetChecked(suf.playerpettarget.Enabled)
 mnuitems.cTargetTarget:SetChecked(suf.targettarget.Enabled)
 mnuitems.cTargetPet:SetChecked(suf.targetpet.Enabled)
 mnuitems.cTargetPetTarget:SetChecked(suf.targetpettarget.Enabled)
 mnuitems.cStatK:SetChecked(suf.UI.K == "K")
 
 mnuitems.HudScale:SetValue(suf.UI.Scale * 100)
 mnuitems.HudScaleVal:SetText(suf.UI.Scale * 100)

 mnuitems.HorzOffset:SetValue(suf.UI.OffsetX)
 mnuitems.HorzOffsetVal:SetText(suf.UI.OffsetX)

 mnuitems.VertOffset:SetValue(suf.UI.OffsetY)
 mnuitems.VertOffsetVal:SetText(suf.UI.OffsetY)

 mnuitems.cParty:SetChecked(not pfc.UI.Enabled)


 mnuitems.cAuras:SetChecked(not suf.Auras.Enabled)
 mnuitems.cShowAll:SetChecked(smu.Auras.ShowAll)

 mnuitems.cSwap:SetChecked(suf.Auras.Swap)
 mnuitems.cCDBD:SetChecked(not suf.Auras.CooldownBackdrop)
 

 mnuitems.cBuffs:SetChecked(not suf.Auras.Buffs.Enabled)
 mnuitems.cBuffBar:SetChecked(suf.Auras.Buffs.Bars)
 mnuitems.cBuffName:SetChecked(suf.Auras.Buffs.Names)
 mnuitems.cBuffCD:SetChecked(suf.Auras.Buffs.CD)
 mnuitems.cPlayerBuffs:SetChecked(suf.Auras.Buffs.PlayerOnly)

 mnuitems.cDebuffs:SetChecked(not suf.Auras.Debuffs.Enabled)
 mnuitems.cDebuffBar:SetChecked(suf.Auras.Debuffs.Bars)
 mnuitems.cDebuffName:SetChecked(suf.Auras.Debuffs.Names)
 mnuitems.cDebuffCD:SetChecked(suf.Auras.Debuffs.CD)
 mnuitems.cPlayerDebuffs:SetChecked(suf.Auras.Debuffs.PlayerOnly)

 
 
 
 mnuitems.MaxBuffBars:SetValue(suf.Auras.Buffs.Max)
 mnuitems.MaxBuffBarsVal:SetText(suf.Auras.Buffs.Max)

 mnuitems.MaxDebuffBars:SetValue(suf.Auras.Debuffs.Max)
 mnuitems.MaxDebuffBarsVal:SetText(suf.Auras.Debuffs.Max)


 mnuitems.cRange:SetChecked(suf.RangeTransparency)

 mnuitems.cOOCAlpha:SetValue(suf.UI.player.OOCAlpha * 100)
 mnuitems.cCombatAlpha:SetValue(suf.UI.player.CombatAlpha * 100)
 mnuitems.cOOCAlphaVal:SetText(suf.UI.player.OOCAlpha * 100)
 mnuitems.cCombatAlphaVal:SetText(suf.UI.player.CombatAlpha * 100)

 mnuitems.cInsideAlpha:SetValue(suf.UI.target.InsideAlpha * 100)
 mnuitems.cOutsideAlpha:SetValue(suf.UI.target.OutsideAlpha * 100)
 mnuitems.cInsideAlphaVal:SetText(suf.UI.target.InsideAlpha * 100)
 mnuitems.cOutsideAlphaVal:SetText(suf.UI.target.OutsideAlpha * 100)


 
 
 mnuitems.cComboPoints:SetChecked(cfg.ComboPoints.UI.Enabled)
 
 mnuitems.comboHorzOffset:SetValue(cfg.ComboPoints.UI.OffsetX)
 mnuitems.comboHorzOffsetVal:SetText(cfg.ComboPoints.UI.OffsetX)

 mnuitems.comboVertOffset:SetValue(cfg.ComboPoints.UI.OffsetY)
 mnuitems.comboVertOffsetVal:SetText(cfg.ComboPoints.UI.OffsetY)

 mnuitems.cFrameColor.clr = {r=suf.Clr["Dark"].r, g=suf.Clr["Dark"].g, b=suf.Clr["Dark"].b }
 mnuitems.cFrameColor.clrTexture:SetColorTexture(suf.Clr["Dark"].r, suf.Clr["Dark"].g, suf.Clr["Dark"].b )

 mnuitems.cFrameFlair.clr = {r=suf.Clr["Underlay"].r, g=suf.Clr["Underlay"].g, b=suf.Clr["Underlay"].b }
 mnuitems.cFrameFlair.clrTexture:SetColorTexture(suf.Clr["Underlay"].r, suf.Clr["Underlay"].g, suf.Clr["Underlay"].b )
 
 mnuitems.cFriendlyHealthColor.clr = {r=suf.Clr["HealthFriendly"].r, g=suf.Clr["HealthFriendly"].g, b=suf.Clr["HealthFriendly"].b}
 mnuitems.cFriendlyHealthColor.clrTexture:SetColorTexture(suf.Clr["HealthFriendly"].r, suf.Clr["HealthFriendly"].g, suf.Clr["HealthFriendly"].b)
 
 mnuitems.cTrivial.clr = {r=suf.Clr["HealthTrivial"].r, g=suf.Clr["HealthTrivial"].g, b=suf.Clr["HealthTrivial"].b}
 mnuitems.cTrivial.clrTexture:SetColorTexture(suf.Clr["HealthTrivial"].r, suf.Clr["HealthTrivial"].g, suf.Clr["HealthTrivial"].b)


 
 mnuitems.cNonInterruptibleSpell.clr = {r=suf.Clr["NonInterruptibleSpell"].r, g=suf.Clr["NonInterruptibleSpell"].g, b=suf.Clr["NonInterruptibleSpell"].b}
 mnuitems.cNonInterruptibleSpell.clrTexture:SetColorTexture(suf.Clr["NonInterruptibleSpell"].r, suf.Clr["NonInterruptibleSpell"].g, suf.Clr["NonInterruptibleSpell"].b)
 
 mnuitems.cFriendlySpell.clr = {r=suf.Clr["FriendlySpell"].r, g=suf.Clr["FriendlySpell"].g, b=suf.Clr["FriendlySpell"].b}
 mnuitems.cFriendlySpell.clrTexture:SetColorTexture(suf.Clr["FriendlySpell"].r, suf.Clr["FriendlySpell"].g, suf.Clr["FriendlySpell"].b)
 
 mnuitems.cHostileSpell.clr = {r=suf.Clr["HostileSpell"].r, g=suf.Clr["HostileSpell"].g, b=suf.Clr["HostileSpell"].b}
 mnuitems.cHostileSpell.clrTexture:SetColorTexture(suf.Clr["HostileSpell"].r, suf.Clr["HostileSpell"].g, suf.Clr["HostileSpell"].b)


 
 for k, v in pairs(clrs) do
  mnuitems[v].clr = {r=suf.Clr[k].r, g=suf.Clr[k].g, b=suf.Clr[k].b }
  mnuitems[v].clrTexture:SetColorTexture(suf.Clr[k].r, suf.Clr[k].g, suf.Clr[k].b )
 end 
 
  
 mnuitems.cBuffColor.clr = {r=suf.Clr["Buff"].r, g=suf.Clr["Buff"].g, b=suf.Clr["Buff"].b}
 mnuitems.cBuffColor.clrTexture:SetColorTexture(suf.Clr["Buff"].r, suf.Clr["Buff"].g, suf.Clr["Buff"].b)
 
 mnuitems.cDebuffColor.clr = {r=suf.Clr["Debuff"].r, g=suf.Clr["Debuff"].g, b=suf.Clr["Debuff"].b}
 mnuitems.cDebuffColor.clrTexture:SetColorTexture(suf.Clr["Debuff"].r, suf.Clr["Debuff"].g, suf.Clr["Debuff"].b)

 
 
 
 
 mnuitems.cHealthByClass:SetChecked(suf.ColorOptions.Health == sui.Structs.By.Class)
 mnuitems.cUnitBorderByClass:SetChecked(suf.ColorOptions.UnitBorder == sui.Structs.By.Class)
 mnuitems.cUnitFlairByClass:SetChecked(suf.ColorOptions.UnitFlair == sui.Structs.By.Class)
 
 
-- sui.Modules.Main:OnConfigUpdated()
end



local function tcopy(to, from)   -- "to" must be a table (possibly empty)
 for k,v in pairs(from) do if type(v) == "table" then if type(to[k]) ~= "table" then to[k] = {} end tcopy(to[k], v) else to[k] = v end end
end

local function ResetColors()
 tcopy(suf.Clr, SkyUI.Clr)
 ReloadUI()
end

SLASH_SKYUI1 = "/skyui"
SlashCmdList["SKYUI"] = function(msg, editBox) if SkyUIConfigMenu:IsVisible() then SkyUIConfigMenu:Hide() else SkyUIConfigMenu:Show() end end

SLASH_SKY1 = "/sky"
SlashCmdList["SKY"] = function(msg, editBox) if SkyUIConfigMenu:IsVisible() then SkyUIConfigMenu:Hide() else SkyUIConfigMenu:Show() end end

StaticPopupDialogs["ResetColorsPrompt"] = {
  text = "Resetting colors requires a reload. Is that okay?",
  button1 = "Reset and Reload",
  button2 = "Cancel",
  OnAccept = function()
   ResetColors()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}









